From 9349db72c70a18a90940fe1b6ba2b5b6fd6a67fb Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:10 +0000
Subject: [PATCH 718/1001] Convert the feed widget


---

diff --git a/hubs/widgets/feed/__init__.py b/hubs/widgets/feed/__init__.py
new file mode 100644
index 0000000..678152d
--- /dev/null
+++ b/hubs/widgets/feed/__init__.py
@@ -0,0 +1,48 @@
+from __future__ import unicode_literals
+
+
+from hubs import validators
+from hubs.widgets.chrome import panel
+from hubs.widgets.base import Widget, WidgetView
+
+import logging
+log = logging.getLogger('hubs')
+
+
+class Feed(Widget):
+
+    name = "feed"
+    position = "left"
+    arguments = [
+        {
+            "name": "username",
+            "label": "Username",
+            "default": None,
+            "validator": validators.username,
+            "help": "A FAS username.",
+        }, {
+            "name": "message_limit",
+            "label": "Message limit",
+            "default": 20,
+            "validator": validators.integer,
+            "help": "Max number of feed messages to display.",
+        }]
+
+
+class BaseView(WidgetView):
+
+    name = "root"
+    url_rules = ["/"]
+    template_name = "templates/feed.html"
+    chrome = panel("Live Feed")
+
+    def get_context(self, instance, *args, **kwargs):
+        # Avoid circular import
+        from hubs.app import app
+        username = instance.config["username"]
+        feed_url = app.config['SSE_URL'] + username
+        return dict(
+            matches=[],
+            message_limit=instance.config["message_limit"],
+            feed_url=feed_url,
+            )

